jobs
===

显示Linux中的任务列表及任务状态

## 补充说明

**jobs命令** 用于显示Linux中的任务列表及任务状态，包括后台运行的任务。该命令可以显示任务号及其对应的进程号。其中，任务号是以普通用户的角度进行的，而进程号则是从系统管理员的角度来看的。一个任务可以对应于一个或者多个进程号。

在Linux系统中执行某些操作时候，有时需要将当前任务暂停调至后台，或有时须将后台暂停的任务重启开启并调至前台，这一序列的操作将会使用到 jobs、bg、和 fg 三个命令以及两个快捷键来完成。

###  语法

```shell
jobs(选项)(参数)
```

###  选项

```shell
-l：显示进程号；
-p：仅任务对应的显示进程号；
-n：显示任务状态的变化；
-r：仅输出运行状态（running）的任务；
-s：仅输出停止状态（stoped）的任务。
```

###  参数

任务标识号：指定要显示的任务识别号。

###  实例

使用jobs命令显示当前系统的任务列表，输入如下命令：

```shell
jobs -l               #显示当前系统的任务列表
```

上面的命令执行后，将显示出当前系统下的任务列表信息，具体如下所示：

```shell
[1] + 1903 运行中          find / -name password &
```

注意：要得到以上输出信息，必须在执行jobs命令之前执行命令`find / -name password &`。否则，执行jobs命令不会显示任何信息。

其中，输出信息的第一列表示任务编号，第二列表示任务所对应的进程号，第三列表示任务的运行状态，第四列表示启动任务的命令。


<!-- Linux命令行搜索引擎：https://jaywcjlove.github.io/linux-command/ -->